/***********************************************************************************************************************************************************************/
/* Arduino Compatible Hardware Wire Library for GR-SAKURA                                                                                                              */
/* Version b0.1                                                                                                                                                        */
/*---<Not supported now>-----------------------------------------------------------------------------------------------------------------------------------------------*/
/* Wire Slave Mode                                                                                                                                                     */
/*---<Not guarantee now>-----------------------------------------------------------------------------------------------------------------------------------------------*/
/* Fast-mode Plus(Fm+) Mode                                                                                                                                            */
/*---<Update Log>------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*  2013/10/24   ver. b0.1   Beta version                                                                                                                              */
/*                                                                                                                                                                     */
/***********************************************************************************************************************************************************************/
#include "hardWire.h"
//#include "vect.h"

/***** NXϐ **********************************************************************************************************************************************/

uint8_t TwoHardWire::txAddress = 0;                                               /* MɎgpAhXi[ϐ                                                  */
uint8_t TwoHardWire::txBuffer[BUFFER_LENGTH];                                     /* Mf[^obt@ϐ                                                            */
uint8_t TwoHardWire::txBufferLength = 0;                                          /* Mf[^i[ϐ                                                        */
uint8_t TwoHardWire::txBufferIndex = 0;                                           /* Mf[^JEgϐ                                                  */

uint8_t TwoHardWire::rxBuffer[BUFFER_LENGTH];                                     /* Mf[^obt@ϐ                                                            */
uint8_t TwoHardWire::rxBufferLength = 0;                                          /* Mf[^i[ϐ                                                        */
uint8_t TwoHardWire::rxBufferIndex = 0;                                           /* Mf[^JEgϐ                                                  */

void (*TwoHardWire::user_onRequest0)(void);                                       /* X[u0Mp荞݊֐o^|C^()                                   */
void (*TwoHardWire::user_onRequest1)(void);                                       /* X[u1Mp荞݊֐o^|C^()                                   */
void (*TwoHardWire::user_onRequest2)(void);                                       /* X[u2Mp荞݊֐o^|C^()                                   */

void (*TwoHardWire::user_onReceive0)(int);                                        /* X[u0Mp荞݊֐o^|C^()                                   */
void (*TwoHardWire::user_onReceive1)(int);                                        /* X[u1Mp荞݊֐o^|C^()                                   */
void (*TwoHardWire::user_onReceive2)(int);                                        /* X[u2Mp荞݊֐o^|C^()                                   */

/***** RXgN^ **************************************************************************************************************************************************/

TwoHardWire::TwoHardWire()
{
}

/***** pubN\bh **********************************************************************************************************************************************/

void TwoHardWire::begin(void){
  SYSTEM.PRCR.BIT.PRC0   = 0x01u;                                                 /* NbNH֘AWX^ւ݂̏                                    */
  SYSTEM.PRCR.BIT.PRC1   = 0x01u;                                                 /* 샂[hAd͒ጸ@\A\tgEFAZbg֘AWX^ւ݂̏  */
  MSTP_RIIC0             = 0x00u;                                                 /* I2CoXC^tF[X0W[XgbvԂ̉                                */
  PORT1.PDR.BYTE        &= 0xF3u;                                                 /* SCL0  SDA0 s͂ɐݒ                                                     */
  PORT1.PMR.BYTE        |= 0x0Cu;                                                 /* SCL0  SDA0 sӋ@\(RIIC0)ƂĎgp                                      */
  SYSTEM.PRCR.BIT.PRC0   = 0x00u;                                                 /* NbNH֘AWX^ւ݂̏֎~                                    */
  SYSTEM.PRCR.BIT.PRC1   = 0x00u;                                                 /* 샂[hAd͒ጸ@\A\tgEFAZbg֘AWX^ւ݂̏֎~  */
  
  
  /*                                                  Package
                                        Port 176-pin 144-pin 100-pin 80-pin
    RIIC0 	SCL0[FM+]   (input/output) 	P12 	 	                 	 
            SDA0[FM+]   (input/output) 	P13 	 	                  
    RIIC1 	SCL1        (input/output) 	P21 		           ~      ~
            SDA1        (input/output) 	P20 		           ~      ~ 
    RIIC2 	SCL2-DS     (input/output) 	P16 		                 
            SDA2-DS     (input/output) 	P17 		                 	 
    RIIC3 	SCL3        (input/output) 	PC0 		           ~      ~	 
            SDA3        (input/output) 	PC1 		           ~      ~ 
  */
  MPC.PWPR.BIT.PFSWE     = 0x01u;                                                 /* PFSWX^ւ݂̏                                                     */
  MPC.PWPR.BIT.B0WI      = 0x00u;                                                 /* PFSWErbgւ݂̏                                                     */
  MPC.P13PFS.BYTE        = 0x0Fu;                                                 /* Ӌ@\RIIC0SCL0I                                                       */
  MPC.P12PFS.BYTE        = 0x0Fu;                                                 /* Ӌ@\RIIC0SDA0I                                                       */
  MPC.PWPR.BIT.B0WI      = 0x01u;                                                 /* PFSWErbgւ݂̏֎~                                                     */
  
  RIIC0.ICCR1.BIT.ICE    = 0x00u;                                                 /* I2CoXC^tF[X֎~iSCL0ASDA0[q쓮ԁj                           */
  RIIC0.ICCR1.BIT.IICRST = 0x01u;                                                 /* RIIC/Zbg                                                             */
  RIIC0.ICCR1.BIT.IICRST = 0x00u;                                                 /* RIIC/Zbg                                                             */
  
  RIIC0.ICSER.BYTE       = 0x00u;
  
  RIIC0.ICMR1.BIT.CKS    = 0x03u;                                                   /* NbNPCLK(48MHz)/8=6MHzɐݒ                                        */
  RIIC0.ICBRL.BYTE       = 0xFDu;                                                   /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICBRH.BYTE       = 0xFDu;                                                   /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICFER.BIT.FMPE   = 0x00u;                                                   /* SCL0[q/SDA0[qStandard-mode,Fast-modepX[vHgp            */
    
  RIIC0.ICFER.BYTE       = 0x00u;                                                 /* I2C oXt@NVCl[uWX^NA                                  */
  
  RIIC0.ICMR1.BIT.CKS    = 0x03u;                                                 /* NbNPCLK(48MHz)/8=6MHzɐݒ                                        */
  RIIC0.ICBRL.BYTE       = 0xFDu;                                                 /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICBRH.BYTE       = 0xFDu;                                                 /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICFER.BIT.FMPE   = 0x00u;                                                 /* SCL0[q/SDA0[qStandard-mode,Fast-modepX[vHgp            */
  
  RIIC0.ICMR2.BYTE       = 0x00u;                                                 /* I2C oX[hWX^2NA                                                   */
  
  RIIC0.ICMR2.BIT.TMOS   = 0x01u;                                                 /* V[g[hI                                                              */
  RIIC0.ICMR2.BIT.TMOL   = 0x01u;                                                 /* SCL0CLowŃJEgL                                                     */
  RIIC0.ICMR2.BIT.TMOH   = 0x01u;                                                 /* SCL0CHighŃJEgL                                                    */
  
  RIIC0.ICMR3.BYTE       = 0x00u;                                                 /* I2C oX[hWX^3NA                                                   */
  RIIC0.ICMR3.BIT.WAIT   = 0x01u;                                                 /* WAITi9NbNڂ1NbNڂ̊ԂLowɃz[hj                       */
  
  RIIC0.ICFER.BIT.TMOE   = 0x01u;                                                 /* ^CAEgo@\L                                                          */
  
  RIIC0.ICIER.BYTE       = 0x00u;                                                 /* I2C oXC^vgCl[uWX^NA(S荞݋֎~)                    */
  
  RIIC0.ICMR1.BIT.MTWP   = 0x01u;                                                 /* ICCR2.MST, TRSrbgւ݂̏                                            */
  RIIC0.ICCR1.BIT.ICE    = 0x01u;                                                 /* iSCL0ASDA0[q쓮ԁj                                                    */
  
/***** ϐ ****************************************************************************************************************************************************/
  
  txAddress      = 0;
  txBufferIndex  = 0;
  rxBufferLength = 0;
  rxBufferIndex  = 0;
  rxBufferLength = 0;
  
  for(int i=0;i<BUFFER_LENGTH;i++){
    txBuffer[i]  = 0;
    rxBuffer[i]  = 0;
  }
}

/***********************************************************************************************************************************************************************/

void TwoHardWire::begin(uint8_t address0, uint8_t address1, uint8_t address2){
  int i;
  SYSTEM.PRCR.BIT.PRC0    = 0x01u;                                                /* NbNH֘AWX^ւ݂̏                                    */
  SYSTEM.PRCR.BIT.PRC1    = 0x01u;                                                /* 샂[hAd͒ጸ@\A\tgEFAZbg֘AWX^ւ݂̏  */
  MSTP_RIIC0              = 0x00u;                                                /* I2CoXC^tF[X0W[XgbvԂ̉                                */
  PORT1.PDR.BYTE         &= 0xF3u;                                                /* SCL0  SDA0 s͂ɐݒ                                                     */
  PORT1.PMR.BYTE         |= 0x0Cu;                                                /* SCL0  SDA0 sӋ@\(RIIC0)ƂĎgp                                      */
  SYSTEM.PRCR.BIT.PRC0    = 0x00u;                                                /* NbNH֘AWX^ւ݂̏֎~                                    */
  SYSTEM.PRCR.BIT.PRC1    = 0x00u;                                                /* 샂[hAd͒ጸ@\A\tgEFAZbg֘AWX^ւ݂̏֎~  */
  
  
  /*                                                  Package
                                        Port 176-pin 144-pin 100-pin 80-pin
    RIIC0 	SCL0[FM+]   (input/output) 	P12 	 	                 
            SDA0[FM+]   (input/output) 	P13 	 	                 
    RIIC1 	SCL1        (input/output) 	P21 		           ~      ~
            SDA1        (input/output) 	P20 		           ~      ~
    RIIC2 	SCL2-DS     (input/output) 	P16 		                 
            SDA2-DS     (input/output) 	P17 		                 
    RIIC3 	SCL3        (input/output) 	PC0 		           ~      ~
            SDA3        (input/output) 	PC1 		           ~      ~
  */
  MPC.PWPR.BIT.PFSWE      = 0x01u;                                                /* PFSWX^ւ݂̏                                                     */
  MPC.PWPR.BIT.B0WI       = 0x00u;                                                /* PFSWErbgւ݂̏                                                     */
  MPC.P13PFS.BYTE         = 0x0Fu;                                                /* Ӌ@\RIIC0SCL0I                                                       */
  MPC.P12PFS.BYTE         = 0x0Fu;                                                /* Ӌ@\RIIC0SDA0I                                                       */
  MPC.PWPR.BIT.B0WI       = 0x01u;                                                /* PFSWErbgւ݂̏֎~                                                     */
  
  RIIC0.ICCR1.BIT.ICE     = 0x00u;                                                /* I2CoXC^tF[X֎~iSCL0ASDA0[q쓮ԁj                           */
  RIIC0.ICCR1.BIT.IICRST  = 0x01u;                                                /* RIIC/Zbg                                                             */
  RIIC0.ICCR1.BIT.IICRST  = 0x00u;                                                /* RIIC/Zbg                                                             */
  
  RIIC0.ICSER.BYTE        = 0x00u;                                                /* ICSERWX^NA                                                             */
  
  if(address0 == 0){                                                              /* X[uAhX0'0'(o^)Ȃ                                              */
    RIIC0.ICSER.BIT.SAR0E = 0x00u;                                                /* X[uAhX0𖳌ɂ                                                     */
  } else {                                                                        /* X[uAhX0'0'łȂ(AhXL)                                    */
    RIIC0.ICSER.BIT.SAR0E = 0x01u;                                                /* X[uAhX0Lɂ                                                     */
    RIIC0.SARU0.BIT.FS    = 0x00u;                                                /* 7rbgAhXtH[}bgI                                                   */
    RIIC0.SARL0.BIT.SVA   = address0;                                             /* 7rbgAhXX[uAhX0ɓo^                                          */
  }
  if(address1 == 0){                                                              /* X[uAhX1'0'(o^)Ȃ                                              */
    RIIC0.ICSER.BIT.SAR1E = 0x00u;                                                /* X[uAhX1𖳌ɂ                                                     */
  } else {                                                                        /* X[uAhX1'0'łȂ(AhXL)                                    */
    RIIC0.ICSER.BIT.SAR1E = 0x01u;                                                /* X[uAhX1Lɂ                                                     */
    RIIC0.SARU1.BIT.FS    = 0x00u;                                                /* 7rbgAhXtH[}bgI                                                   */
    RIIC0.SARL1.BIT.SVA   = address1;                                             /* 7rbgAhXX[uAhX1ɓo^                                          */
  }
  if(address2 == 0){                                                              /* X[uAhX2'0'(o^)Ȃ                                              */
    RIIC0.ICSER.BIT.SAR2E = 0x00u;                                                /* X[uAhX2𖳌ɂ                                                     */
  } else {                                                                        /* X[uAhX2'0'łȂ(AhXL)                                    */
    RIIC0.ICSER.BIT.SAR2E = 0x01u;                                                /* X[uAhX2Lɂ                                                     */
    RIIC0.SARU2.BIT.FS    = 0x00u;                                                /* 7rbgAhXtH[}bgI                                                   */
    RIIC0.SARL2.BIT.SVA   = address2;                                             /* 7rbgAhXX[uAhX2ɓo^                                          */
  }
  
  RIIC0.ICFER.BYTE        = 0x00u;                                                /* I2C oXt@NVCl[uWX^NA                                  */
  
  RIIC0.ICMR1.BIT.CKS     = 0x03u;                                                /* NbNPCLK(48MHz)/8=6MHzɐݒ                                        */
  RIIC0.ICBRL.BYTE        = 0xFDu;                                                /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICBRH.BYTE        = 0xFDu;                                                /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
  RIIC0.ICFER.BIT.FMPE    = 0x00u;                                                /* SCL0[q/SDA0[qStandard-mode,Fast-modepX[vHgp            */
  
  RIIC0.ICMR2.BYTE        = 0x00u;                                                /* I2C oX[hWX^2NA                                                   */
  
  RIIC0.ICMR2.BIT.TMOS    = 0x01u;                                                /* V[g[hI                                                              */
  RIIC0.ICMR2.BIT.TMOL    = 0x01u;                                                /* SCL0CLowŃJEgL                                                     */
  RIIC0.ICMR2.BIT.TMOH    = 0x01u;                                                /* SCL0CHighŃJEgL                                                    */
  
  RIIC0.ICMR3.BYTE        = 0x00u;                                                /* I2C oX[hWX^3NA                                                   */
  RIIC0.ICMR3.BIT.WAIT    = 0x01u;                                                /* WAITi9NbNڂ1NbNڂ̊ԂLowɃz[hj                       */
  
  RIIC0.ICFER.BIT.TMOE    = 0x01u;                                                /* ^CAEgo@\L                                                          */
  
  RIIC0.ICIER.BYTE        = 0x00u;                                                /* I2C oXC^vgCl[uWX^NA(S荞݋֎~)                    */
  
  RIIC0.ICIER.BIT.RIE     = 0x01u;                                                /* Mf[^t荞݂                                                      */
  
  IPR(RIIC0,RXI0)         = 0x7u;                                                 /* 荞ݗD揇ʂ7ɂ                                                         */
  IEN(RIIC0,RXI0)         = 0x1u;                                                 /* Mf[^t荞݂Lɂ                                                */
  IR(RIIC0,RXI0)          = 0x0u;                                                 /* Mf[^t荞݃tONA                                          */
  
  RIIC0.ICSR1.BYTE        = 0x00u;                                                /* ICSR1WX^NA                                                             */
  
  RIIC0.ICMR1.BIT.MTWP    = 0x01u;                                                /* ICCR2.MST, TRSrbgւ݂̏                                            */
  RIIC0.ICCR1.BIT.ICE     = 0x01u;                                                /* iSCL0ASDA0[q쓮ԁj                                                    */
  
/***** ϐ ****************************************************************************************************************************************************/
  
  txAddress      = 0;
  txBufferIndex  = 0;
  rxBufferLength = 0;
  rxBufferIndex  = 0;
  rxBufferLength = 0;
  
  for(i=0;i<BUFFER_LENGTH;i++){
    txBuffer[i] = 0;
    rxBuffer[i] = 0;
  }
}

/***********************************************************************************************************************************************************************/

void TwoHardWire::Mode(uint8_t mode){
  if(mode == STANDARD_MODE){                                                      /* STANDARD_MODȄꍇ                                                               */
    RIIC0.ICMR1.BIT.CKS  = 0x03u;                                                 /* NbNPCLK(48MHz)/8=6MHzɐݒ                                        */
    RIIC0.ICBRL.BYTE     = 0xFDu;                                                 /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
    RIIC0.ICBRH.BYTE     = 0xFDu;                                                 /* rbg[g100kbpsɐݒ(f[eB[50%)                                    */
    RIIC0.ICFER.BIT.FMPE = 0x00u;                                                 /* SCL0[q/SDA0[qStandard-mode,Fast-modepX[vHgp            */
  } else if(mode == FAST_MODE){                                                   /* FAST_MODȄꍇ                                                                   */
    RIIC0.ICMR1.BIT.CKS  = 0x02u;                                                 /* NbNPCLK(48MHz)/4=12MHzɐݒ                                       */
    RIIC0.ICBRL.BYTE     = 0xEEu;                                                 /* rbg[g400kbpsɐݒ(f[eB[50%)                                    */
    RIIC0.ICBRH.BYTE     = 0xEEu;                                                 /* rbg[g400kbpsɐݒ(f[eB[50%)                                    */
    RIIC0.ICFER.BIT.FMPE = 0x00u;                                                 /* SCL0[q/SDA0[qStandard-mode,Fast-modepX[vHgp            */
  } else if(mode == FAST_MODE_PLUS){                                              /* FAST_MODE_PLUS̏ꍇ                                                              */
/*---- Fast-mode Plus(Fm+)얢mF ----------------------------------------------------------------------------------------------------------------------------------*/
    RIIC0.ICMR1.BIT.CKS  = 0x01u;                                                 /* NbNPCLK(48MHz)/2=24MHzɐݒ                                       */
    RIIC0.ICBRL.BYTE     = 0xEBu;                                                 /* rbg[g1Mbpsɐݒ(f[eB[50%)                                      */
    RIIC0.ICBRH.BYTE     = 0xEBu;                                                 /* rbg[g1Mbpsɐݒ(f[eB[50%)                                      */
    RIIC0.ICFER.BIT.FMPE = 0x01u;                                                 /* SCL0[q/SDA0[qFast-mode+pX[vHgp                         */
/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
  }
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
void TwoHardWire::beginTransmission(uint8_t addr){
  txAddress = addr;                                                               /* M鑊̃AhXtxAddressɑ                                           */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
boolean TwoHardWire::write(const uint8_t data){
  txBuffer[txBufferIndex] = data;                                                 /* txBuffer[txBufferIndex]1oCgf[^                                  */
  txBufferIndex++;                                                                /* ̔zԍZbg                                                              */
  txBufferLength = txBufferIndex;                                                 /* MoCgXV                                                            */
  return(1);                                                                      /* ݐoCg(1oCg)Ԃ                                               */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::write(const uint8_t* buf, uint8_t quantity){
  uint8_t i = 0;                                                                  /* forp̕ϐ                                                                     */
  uint8_t j = 0;                                                                  /* ݐoCgi[ϐ                                                */

  for(i=0;i<quantity;i++){                                                        /* quantity񕪏                                                              */
    txBuffer[txBufferIndex] = (uint8_t)*buf;                                      /* txBuffer[txBufferIndex]1oCgf[^                                  */
    j++;
    txBufferIndex++;                                                              /* ̔zԍZbg                                                              */
    txBufferLength = txBufferIndex;                                               /* MoCgXV                                                            */
    buf++;                                                                        /* |C^̃AhX1oCg炷(̃f[^)                                     */
  }
  return(j);                                                                      /* ݐoCgԂ                                                        */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::write(const uint32_t* buf, uint8_t quantity, uint8_t type){
  uint8_t i = 0;                                                                  /* forp̕ϐ                                                                     */
  uint8_t k = 0;                                                                  /* dforp̕ϐ                                                               */
  uint8_t j = 0;                                                                  /* ݐoCgi[ϐ                                                */

  for(i=0;i<quantity;i++){                                                        /* quantity񕪏                                                              */
    for(k=0;k<type;k++){                                                          /* 1oCg                                                               */
      txBuffer[txBufferIndex] = (uint8_t)(*buf >> (((type-1)-k)*8));              /* txBuffer[txBufferIndex]1oCgf[^                                  */
      j++;                                                                        /* ݐoCgJEg                                                    */
      txBufferIndex++;                                                            /* ̔zԍZbg                                                              */
      txBufferLength = txBufferIndex;                                             /* MoCgXV                                                            */
    }
    buf++;                                                                        /* |C^̃AhX1oCg炷(̃f[^)                                     */
  }
  return(j);                                                                      /* ݐoCgԂ                                                        */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::write(const uint8_t data, uint8_t quantity){
  uint8_t buf[1] = {(uint8_t)data};                                               /* datazɕϊ                                                                  */
  write(buf, quantity);                                                           /* writeɑĎs                                                               */
  return(1);                                                                      /* ݐoCg(1oCg)Ԃ                                               */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::write(const uint32_t data, uint8_t quantity,uint8_t type){
  uint32_t buf[1] = {(uint32_t)data};                                             /* datazɕϊ                                                                  */
  write(buf, quantity, type);                                                     /* writeɑĎs                                                               */
  return(1);                                                                      /* ݐoCg(1oCg)Ԃ                                               */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::endTransmission(void){
  uint8_t i = 0;                                                                  /* forp̕ϐ                                                                     */
  uint8_t j = 0;                                                                  /* ݐoCgi[ϐ                                                */
  while(RIIC0.ICCR2.BIT.BBSY != 0);                                               /* I2CoXJ(BBSY = 0)ł邱ƂmF                                       */
  RIIC0.ICCR2.BIT.ST = 1;                                                         /* X^[gRfBV̔sv                                            */
  
  while(RIIC0.ICSR2.BIT.TDRE !=1);                                                /* TDREtO1ɂȂ܂ŌJԂ                                                   */
  
  RIIC0.ICDRT = txAddress << 1;                                                   /* ICDRTWX^ɃX[uAhX+R/Wrbg(}X^M:0)                 */
  
  for(i=0;i<txBufferLength;i++){                                                  /* ܂writeŏ񂾃oCg𑗐M                                             */
    do{
      if(RIIC0.ICSR2.BIT.NACKF !=0) return(j);                                    /* NACKFtO0ł邱ƂmF                                                    */
    }while(RIIC0.ICSR2.BIT.TDRE !=1);                                             /* TDREtO1ɂȂ܂ŌJԂ                                                   */
  
    RIIC0.ICDRT = txBuffer[i];                                                    /* ICDRTWX^ɑMf[^                                               */
    txBuffer[i] = 0;                                                              /* txBuffer[i][NA                                                           */
    j++;                                                                          /* M񐔂JEgAbv                                                        */
  }
       
  while(RIIC0.ICSR2.BIT.TEND != 1);                                               /* f[^MI܂őҋ@                                                      */
  
  RIIC0.ICSR2.BIT.STOP = 0;                                                       /* STOPtONA                                                                  */
  RIIC0.ICCR2.BIT.SP  = 1;                                                        /* XgbvRfBV̔sv                                            */
  
  while(RIIC0.ICSR2.BIT.STOP != 1);                                               /* ~̔s܂őҋ@                                                  */
  
  RIIC0.ICSR2.BIT.NACKF = 0;                                                      /* NACKtONA                                                                  */
  RIIC0.ICSR2.BIT.STOP = 0;                                                       /* STOPtONA                                                                  */
  txBufferIndex = 0;                                                              /* writeŏ񂾃oCgZbg(0)                                          */
  txBufferLength = 0;
  
  return(j);                                                                      /* MoCgԂ                                                        */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
int TwoHardWire::requestFrom(uint8_t read_add, uint8_t quantity){
  volatile uint8_t dummy_read = 0;                                                /* _~[f[^i[ϐ                                                              */
  volatile uint8_t data_cnt = 1;                                                  /* ɑf[^ԍi[ϐ                                                  */
  rxBufferIndex = 0;                                                              /* Mi[ϐNA                                                  */
  
  RIIC0.ICMR3.BIT.WAIT  = 0;                                                      /* WAITȂ                                                                          */
  RIIC0.ICMR3.BIT.ACKWP = 1;                                                      /* ACKBTւ݂̏                                                       */
  RIIC0.ICMR3.BIT.ACKBT = 0;                                                      /* ACK𑗐M                                                                   */
  
  while(RIIC0.ICCR2.BIT.BBSY != 0);                                               /* I2CoXJ(BBSY = 0)ł邱ƂmF                                       */
  
  RIIC0.ICCR2.BIT.ST = 1;                                                         /* X^[gRfBV̔sv                                            */
  
  while(RIIC0.ICSR2.BIT.TDRE !=1);                                                /* TDREtO1ɂȂ܂ŌJԂ                                                   */
  
  RIIC0.ICDRT = (read_add << 1) | 0x01u;                                          /* ICDRTWX^ɃX[uAhX+R/Wrbg(}X^M:1)                 */
  
  while(RIIC0.ICSR2.BIT.RDRF != 1                                                 /* RDRFtO1ɂȂ܂ł                                                         */
     && RIIC0.ICSR2.BIT.TMOF != 1);                                               /* ^CAEg܂őҋ@                                                          */
  
  if(RIIC0.ICSR2.BIT.NACKF == 1                                                   /* NACK(Ȃ)                                                                  */
  || RIIC0.ICSR2.BIT.TMOF  == 1){                                                 /* ^CAEgȂ                                                                */
  
    RIIC0.ICSR2.BIT.STOP = 0;                                                     /* STOPtONA                                                                  */
    RIIC0.ICCR2.BIT.SP   = 1;                                                     /* XgbvRfBV̔sv                                            */
    return(-1);                                                                   /* G[(-1)Ԃ                                                                  */
    dummy_read = RIIC0.ICDRR;                                                     /* _~[[h                                                                      */
  } else {
    dummy_read = RIIC0.ICDRR;                                                     /* _~[[h                                                                      */
    if(quantity != 1){                                                            /* MoCg1łȂ                                                     */
      while(1){
        while(RIIC0.ICSR2.BIT.RDRF !=1);                                          /* RDRFtO1ɂȂ܂őҋ@                                                       */
        
        if(data_cnt < quantity-1){                                                /* ̃f[^ŏI-1̃f[^łȂȂ                                              */
          if(data_cnt == quantity-2){                                             /* ̃f[^ŏI-2̃f[^Ȃ                                                    */
            RIIC0.ICMR3.BIT.WAIT = 1;                                             /* WAIT                                                                          */
          }
          rxBuffer[data_cnt-1] = RIIC0.ICDRR;                                     /* ICDRRǂݍ                                                                   */
          data_cnt++;                                                             /* f[^ԍJEgAbv                                                        */
        } else {                                                                  /* ̃f[^ŏI-1̃f[^Ȃ                                                    */
          break;                                                                  /* [vEo                                                                        */
        }
      }
      
      RIIC0.ICMR3.BIT.ACKBT = 1;                                                  /* NACK𑗐M                                                                  */
      
      rxBuffer[data_cnt-1] = RIIC0.ICDRR;                                         /* ICDRRǂݍ(ŏI-1̃f[^)                                                   */
      data_cnt++;                                                                 /* f[^ԍJEgAbv                                                        */
    }
      
    while(RIIC0.ICSR2.BIT.RDRF !=1);                                              /* RDRFtO1ɂȂ܂őҋ@                                                       */
    
    RIIC0.ICSR2.BIT.STOP = 0;                                                     /* STOPtONA                                                                  */
    RIIC0.ICCR2.BIT.SP   = 1;                                                     /* XgbvRfBV̔sv                                            */
    
    rxBuffer[data_cnt-1] = RIIC0.ICDRR;                                           /* ICDRRǂݍ(ŏIf[^)                                                       */
    
    RIIC0.ICMR3.BIT.WAIT = 0;                                                     /* WAITȂ(NA)                                                                  */
  }
  
  while(RIIC0.ICSR2.BIT.STOP != 1);                                               /* ~̔s܂őҋ@                                                  */
  
  RIIC0.ICMR3.BIT.ACKWP = 0;                                                      /* ACKBTւ݂̏֎~                                                       */
  RIIC0.ICMR3.BIT.WAIT  = 0;                                                      /* WAITȂ(NA)                                                                  */
  
  RIIC0.ICSR2.BIT.NACKF = 0;                                                      /* NACKtONA                                                                  */
  RIIC0.ICSR2.BIT.STOP  = 0;                                                      /* STOPtONA                                                                  */
  
  rxBufferLength = data_cnt;                                                      /* MoCgrxBufferLengthɑ                                            */
  return(data_cnt);                                                               /* MoCgԂ                                                            */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
int TwoHardWire::requestFrom(int read_add, int quantity){
  return(requestFrom((uint8_t)read_add, (uint8_t)quantity));                      /* requestFrom̈int^uint8_t^ɕϊ                                         */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::read(void){
  uint8_t read = rxBuffer[rxBufferIndex];                                         /* Mf[^obt@Ɋi[Ăf[^1oCgǂݍ                         */
  rxBuffer[rxBufferIndex] = 0;                                                    /* ǂݍ񂾌̎Mf[^obt@1oCgNA                                   */
  rxBufferIndex++;                                                                /* ǂݍރf[^̔ԍZbg                                                    */
  return(read);                                                                   /* ǂݍ1oCg̃f[^Ԃ                                                 */
}

/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint8_t TwoHardWire::available(void){
  return(rxBufferLength - rxBufferIndex);                                         /* ǂݍłȂc̃oCgԂ                                              */
}

/**** 疢 ***************************************************************************************************************************************************/

// sets function called on slave read
void TwoHardWire::onRequest0( void (*function)(void)){
  user_onRequest0 = function;
}

void TwoHardWire::onRequest1( void (*function)(void)){
  user_onRequest1 = function;
}

void TwoHardWire::onRequest2( void (*function)(void)){
  user_onRequest2 = function;
}

// sets function called on slave write
void TwoHardWire::onReceive0( void (*function)(int) ){
  user_onReceive0 = function;
}

void TwoHardWire::onReceive1( void (*function)(int) ){
  user_onReceive1 = function;
}

void TwoHardWire::onReceive2( void (*function)(int) ){
  user_onReceive2 = function;
}

// RIIC1 RXI0
void Excep_RIIC0_RXI0(void){
  int howmany;
  digitalWrite(PIN_LED0,HIGH);
  boolean slave_mode = 0;
  RIIC0.ICIER.BIT.RIE = 0;
  IEN(RIIC0,RXI0) = 0x00u;
  slave_mode = RIIC0.ICDRR & 0x01u;
  if(RIIC0.ICSR1.BIT.AAS0 == 1 || RIIC0.ICSR1.BIT.AAS1 == 1 || RIIC0.ICSR1.BIT.AAS2 == 1){
    if(slave_mode == 1){
      if(RIIC0.ICSR1.BIT.AAS0 == 1){
        RIIC0.ICSR1.BIT.AAS0 = 0;
        (*hardWire.user_onRequest0)();
        
      } else if(RIIC0.ICSR1.BIT.AAS1 == 1){
        RIIC0.ICSR1.BIT.AAS1 = 0;
        (*hardWire.user_onRequest1)();
        
      } else if(RIIC0.ICSR1.BIT.AAS2 == 1){
        RIIC0.ICSR1.BIT.AAS2 = 0;
        (*hardWire.user_onRequest2)();
      }
      
    } else {
      if(RIIC0.ICSR1.BIT.AAS0 == 1){
        RIIC0.ICSR1.BIT.AAS0 = 0;
        (*hardWire.user_onReceive0)(howmany);
        
      } else if(RIIC0.ICSR1.BIT.AAS1 == 1){
        RIIC0.ICSR1.BIT.AAS1 = 0;
        (*hardWire.user_onReceive1)(howmany);
        
      } else if(RIIC0.ICSR1.BIT.AAS2 == 1){
        RIIC0.ICSR1.BIT.AAS2 = 0;
        (*hardWire.user_onReceive2)(howmany);
      }
    }
  } else {
    
  }
}

void Excep_RIIC0_SPI0(void){
}

/***** OɃIuWFNg̃CX^X𐶐 *******************************************************************************************************/

TwoHardWire hardWire = TwoHardWire();
